/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of SkewHeap.xs. Do not edit this file, edit SkewHeap.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SkewHeap.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

/*
 * Allocate memory with Newx if it's
 * available - if it's an older perl
 * that doesn't have Newx then we
 * resort to using New.
 */
#ifndef Newx
#define Newx(v, n, t) New(0, v, n, t)
#endif

/*
 * perl object ref to skewheap_t*
 */
#ifndef SKEW
#define SKEW(obj) ((skewheap_t*) SvIV(SvRV(obj)))
#endif

/*
 * Thanks again, MLEHMANN:
 *   http://grokbase.com/t/perl/perl5-porters/097tr5nw6b/perl-67894-multicall-push-requires-perl-core
 */
#ifndef cxinc
#define cxinc() Perl_cxinc(aTHX)
#endif


typedef struct SkewNode {
  struct SkewNode *left;
  struct SkewNode *right;
  SV *value;
} skewnode_t;

typedef struct SkewHeap {
  skewnode_t *root;
  IV size;
  SV *cmp;
} skewheap_t;


static
skewnode_t* new_node(pTHX_ SV *value) {
  skewnode_t *node;
  Newx(node, 1, skewnode_t);
  node->left  = NULL;
  node->right = NULL;
  node->value = newSVsv(value);
  return node;
}

static
skewnode_t* clone_node(pTHX_ skewnode_t *node) {
  if (node == NULL) {
    return NULL;
  }

  skewnode_t *new_node;

  Newx(new_node, 1, skewnode_t);
  new_node->value = newSVsv(node->value);
  new_node->left  = clone_node(aTHX_ node->left);
  new_node->right = clone_node(aTHX_ node->right);

  return new_node;
}

static
void free_node(pTHX_ skewnode_t *node) {
  if (node->left  != NULL) free_node(aTHX_ node->left);
  if (node->right != NULL) free_node(aTHX_ node->right);
  SvREFCNT_dec(node->value);
  Safefree(node);
}


static
SV* new(pTHX_ const char *class, SV *cmp) {
  skewheap_t *heap;
  SV *obj;
  SV *ref;

  Newx(heap, 1, skewheap_t);
  heap->root = NULL;
  heap->size = 0;
  heap->cmp  = cmp;
  SvREFCNT_inc(heap->cmp);

  obj = newSViv((IV) heap);
  ref = newRV_noinc(obj);
  sv_bless(ref, gv_stashpv(class, GV_ADD));
  SvREADONLY_on(obj);

  return ref;
}

static
void DESTROY(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  if (heap->root != NULL) free_node(aTHX_ heap->root);
  SvREFCNT_dec(heap->cmp);
  Safefree(heap);
}


static
size_t walk_tree(skewnode_t *node, skewnode_t *nodes[], size_t idx) {
  size_t inc = 0;
  nodes[ idx ] = node;
  ++inc;

  if (node->left != NULL) {
    inc += walk_tree(node->left, nodes, idx + inc);
  }

  if (node->right != NULL) {
    inc += walk_tree(node->right, nodes, idx + inc);
  }

  return inc;
}

static
SV* to_array(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  skewnode_t *nodes[ heap->size ];
  AV *array = newAV();
  size_t i;

  walk_tree(heap->root, nodes, 0);

  for (i = 0; i < heap->size; ++i) {
    av_push(array, newSVsv( nodes[i]->value ));
  }

  return newRV_noinc( (SV*) array );
}

static
void sort_nodes(pTHX_ skewnode_t *nodes[], int length, SV *cmp) {
  skewnode_t *tmp, *x;
  int p, j;
  int start = 0;
  int end = length - 1;
  int top = 1;
  int stack[end - start + 1];

  stack[0] = start;
  stack[1] = end;

  // set up multicall
  dSP;
  GV *agv, *bgv, *gv;
  HV *stash;

  // code value from sv code ref
  CV *cv = sv_2cv(cmp, &stash, &gv, 0);

  if (cv == Nullcv) {
    croak("Not a subroutine reference");
  }

  agv = gv_fetchpv("main::a", GV_ADD, SVt_PV);
  bgv = gv_fetchpv("main::b", GV_ADD, SVt_PV);
  SAVESPTR(GvSV(agv));
  SAVESPTR(GvSV(bgv));

  dMULTICALL;
  I8 gimme = G_SCALAR;

  PUSH_MULTICALL(cv);
  // multicall ready

  while (top >= 0) {
    end   = stack[top--];
    start = stack[top--];

    x = nodes[end];
    p = start - 1;

    for (j = start; j <= end - 1; ++j) {
      GvSV(agv) = nodes[j]->value;
      GvSV(bgv) = x->value;
      MULTICALL;

      int test = SvIV(*PL_stack_sp);

      if (test < 1) {
        p++;
        tmp = nodes[p];
        nodes[p] = nodes[j];
        nodes[j] = tmp;
      }
    }

    tmp = nodes[++p];
    nodes[p] = nodes[end];
    nodes[end] = tmp;

    if (p - 1 > start) {
      stack[++top] = start;
      stack[++top] = p - 1;
    }

    if (p + 1 < end) {
      stack[++top] = p + 1;
      stack[++top] = end;
    }
  }

  POP_MULTICALL;
}

static
void _merge(pTHX_ SV *heap_ref, SV *heap_ref_a, SV *heap_ref_b) {
  skewheap_t *heap = SKEW(heap_ref);

  skewheap_t *heap_a = SKEW(heap_ref_a);
  skewheap_t *heap_b = SKEW(heap_ref_b);
  skewnode_t *a = heap_a->root;
  skewnode_t *b = heap_b->root;

  size_t size = heap_a->size + heap_b->size;

  skewnode_t *todo[size];
  skewnode_t *nodes[size];
  skewnode_t *node, *prev, *tmp_node;

  int tidx = 0;
  int nidx = 0;
  int i;

  // Set the new heap's size
  heap->size = size;

  // Cut the right subtree from each path
  if (a != NULL) todo[tidx++] = a;
  if (b != NULL) todo[tidx++] = b;

  while (tidx > 0) {
    node = todo[--tidx];

    tmp_node = new_node(aTHX_ node->value);
    tmp_node->left = clone_node(aTHX_ node->left);

    if (node->right != NULL) {
      todo[tidx] = node->right;
      ++tidx;
    }

    nodes[nidx] = tmp_node;
    ++nidx;
  }

  if (nidx > 0) {
    // Sort the subtrees
    if (nidx > 1) {
      sort_nodes(aTHX_ nodes, nidx, heap->cmp);
    }

    // Recombine subtrees
    for (i = nidx; i > 1; --i) {
      node = nodes[i - 1]; // last node
      prev = nodes[i - 2]; // second to last node

      // Set penultimate node's right child to its left (and only) subtree
      if (prev->left != NULL) {
        prev->right = prev->left;
      }

      // Set its left child to the ultimate node
      prev->left = node;
    }

    heap->root = nodes[0];
  }

  return;
}

static
void _merge_destructive(pTHX_ skewheap_t *heap, skewnode_t *a, skewnode_t *b) {
  skewnode_t* todo[heap->size];
  skewnode_t* nodes[heap->size];
  skewnode_t* node;
  skewnode_t* prev;
  int tidx = 0;
  int nidx = 0;
  int i;

  if (a == NULL) {
    heap->root = b;
    return;
  }
  else if (b == NULL) {
    heap->root = a;
    return;
  }

  // Cut the right subtree from each path
  todo[tidx++] = a;
  todo[tidx++] = b;

  while (tidx > 0) {
    node = todo[--tidx];

    if (node->right != NULL) {
      todo[tidx++] = node->right;
      node->right = NULL;
    }

    nodes[nidx++] = node;
  }

  if (nidx == 0) {
    heap->root = NULL;
  }
  else {
    // Sort the subtrees
    if (nidx > 1) {
      sort_nodes(aTHX_ nodes, nidx, heap->cmp);
    }

    // Recombine subtrees
    for (i = nidx; i > 1; --i) {
      node = nodes[i - 1]; // last node
      prev = nodes[i - 2]; // second to last node

      // Set penultimate node's right child to its left (and only) subtree
      if (prev->left != NULL) {
        prev->right = prev->left;
      }

      // Set its left child to the ultimate node
      prev->left = node;
    }

    heap->root = nodes[0];
  }
}

static
IV put_one(pTHX_ SV *ref, SV *value) {
  skewheap_t *heap = SKEW(ref);
  skewnode_t *node;

  node = new_node(aTHX_ value);
  ++heap->size;

  if (heap->root == NULL) {
    heap->root = node;
  } else {
    _merge_destructive(aTHX_ heap, heap->root, node);
  }

  return heap->size;
}

static
SV* take(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  skewnode_t *root = heap->root;
  SV *item;

  if (root != NULL) {
    item = newSVsv(root->value);
    --heap->size;
    _merge_destructive(aTHX_ heap, root->left, root->right);
    root->left  = NULL;
    root->right = NULL;
    free_node(aTHX_ root);
  }
  else {
    item = &PL_sv_undef;
  }

  return item;
}

static
SV* top(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  return heap->root == NULL
      ? &PL_sv_undef
      : newSVsv(heap->root->value);
}

static
IV size(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  return heap->size;
}

static
SV* merge(pTHX_ SV *heap_a, SV *heap_b) {
  SV *new_heap = new(aTHX_ "SkewHeap", SKEW(heap_a)->cmp);
  _merge(aTHX_ new_heap, heap_a, heap_b);
  return new_heap;
}

static
void _explain(pTHX_ SV *out, skewnode_t *node, int depth) {
  int i;

  for (i = 0; i < depth; ++i) sv_catpvn(out, "--", 2);
  sv_catpvf(out, "NODE<%p>\n", (void*)node);
  ++depth;

  for (i = 0; i < depth; ++i) sv_catpvn(out, "--", 2);
  sv_catpvf(out, "VALUE<%p>: ", (void*)node->value);
  sv_catsv(out, sv_mortalcopy(node->value));
  sv_catpvn(out, "\n", 1);

  if (node->left != NULL) {
    for (i = 0; i < depth; ++i) sv_catpvn(out, "--", 2);
    sv_catpvn(out, "LEFT:\n", 6);
    _explain(aTHX_ out, node->left, depth + 1);
  }

  if (node->right != NULL) {
    for (i = 0; i < depth; ++i) sv_catpvn(out, "--", 2);
    sv_catpvn(out, "RIGHT:\n", 7);
    _explain(aTHX_ out, node->right, depth + 1);
  }
}

static
SV* explain(pTHX_ SV *ref) {
  skewheap_t *heap = SKEW(ref);
  SV *out = newSVpvn("", 0);

  sv_catpvn(out, "SKEWHEAP:\n", 10);

  if (heap->root != NULL) {
    _explain(aTHX_ out, heap->root, 2);
  }

  return out;
}


#line 457 "SkewHeap.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 601 "SkewHeap.c"

XS_EUPXS(XS_SkewHeap_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, cmp");
    {
	SV *	RETVAL;
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
	SV *	cmp = ST(1)
;
#line 456 "SkewHeap.xs"
    RETVAL = new(aTHX_ class, cmp);
#line 617 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_skewheap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_skewheap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cmp");
    {
	SV *	RETVAL;
	SV *	cmp = ST(0)
;
#line 463 "SkewHeap.xs"
    RETVAL = new(aTHX_ "SkewHeap", cmp);
#line 637 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
#line 469 "SkewHeap.xs"
    DESTROY(aTHX_ heap);
#line 656 "SkewHeap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SkewHeap_put_one); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_put_one)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "heap, value");
    {
	IV	RETVAL;
	dXSTARG;
	SV *	heap = ST(0)
;
	SV *	value = ST(1)
;
#line 473 "SkewHeap.xs"
    RETVAL = put_one(aTHX_ heap, value);
#line 677 "SkewHeap.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_put)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "heap, ...");
    {
	IV	RETVAL;
	dXSTARG;
	SV *	heap = ST(0)
;
#line 479 "SkewHeap.xs"
    size_t i;
    for (i = 1; i < items; ++i) {
      RETVAL = put_one(aTHX_ heap, ST(i));
    }
#line 700 "SkewHeap.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_take); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_take)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 488 "SkewHeap.xs"
    RETVAL = take(aTHX_ heap);
#line 719 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	IV	RETVAL;
	dXSTARG;
	SV *	heap = ST(0)
;
#line 494 "SkewHeap.xs"
    RETVAL = size(aTHX_ heap);
#line 740 "SkewHeap.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_merge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_merge)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "heap_a, heap_b");
    {
	SV *	RETVAL;
	SV *	heap_a = ST(0)
;
	SV *	heap_b = ST(1)
;
#line 500 "SkewHeap.xs"
    RETVAL = merge(aTHX_ heap_a, heap_b);
#line 761 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_top); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_top)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 506 "SkewHeap.xs"
    RETVAL = top(aTHX_ heap);
#line 781 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_to_array); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_to_array)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 512 "SkewHeap.xs"
    RETVAL = to_array(aTHX_ heap);
#line 801 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SkewHeap_explain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SkewHeap_explain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 518 "SkewHeap.xs"
    RETVAL = explain(aTHX_ heap);
#line 821 "SkewHeap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_SkewHeap); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_SkewHeap)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("SkewHeap::new", XS_SkewHeap_new, file, "$&");
        (void)newXSproto_portable("SkewHeap::skewheap", XS_SkewHeap_skewheap, file, "&");
        (void)newXSproto_portable("SkewHeap::DESTROY", XS_SkewHeap_DESTROY, file, "$");
        (void)newXSproto_portable("SkewHeap::put_one", XS_SkewHeap_put_one, file, "$$");
        (void)newXSproto_portable("SkewHeap::put", XS_SkewHeap_put, file, "$;@");
        (void)newXSproto_portable("SkewHeap::take", XS_SkewHeap_take, file, "$");
        (void)newXSproto_portable("SkewHeap::size", XS_SkewHeap_size, file, "$");
        (void)newXSproto_portable("SkewHeap::merge", XS_SkewHeap_merge, file, "$$");
        (void)newXSproto_portable("SkewHeap::top", XS_SkewHeap_top, file, "$");
        (void)newXSproto_portable("SkewHeap::to_array", XS_SkewHeap_to_array, file, "$");
        (void)newXSproto_portable("SkewHeap::explain", XS_SkewHeap_explain, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

